package org.eco.als.listener;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import org.eco.common.core.exception.BusinessException;
import org.eco.common.core.utils.SpringUtils;
import org.eco.common.core.utils.ValidatorUtils;
import org.eco.common.excel.core.ExcelListener;
import org.eco.common.excel.core.ExcelResult;
import org.eco.common.excel.entity.ExcelResultRes;
import org.eco.common.core.core.domain.model.LoginUser;
import org.eco.als.domain.bo.AirInstallBo;
import org.eco.als.domain.vo.AirInstallImportVo;
import org.eco.als.domain.vo.AirInstallVo;
import org.eco.als.service.IAirInstallService;
import lombok.extern.slf4j.Slf4j;

import java.util.List;

/**
 * 装机信息自定义导入
 *
 * @author wgk
 */
@Slf4j
public class AirInstallImportListener extends AnalysisEventListener<AirInstallImportVo> implements ExcelListener<AirInstallImportVo> {
    private final IAirInstallService airInstallService;

    private final Boolean isUpdateSupport;
    private final LoginUser loginUser;
    private int successNum = 0;
    private int failureNum = 0;
    private final StringBuilder successMsg = new StringBuilder();
    private final StringBuilder failureMsg = new StringBuilder();

    public AirInstallImportListener(Boolean isUpdateSupport, LoginUser loginUser) {
        this.airInstallService = SpringUtils.getBean(IAirInstallService.class);
        this.isUpdateSupport = isUpdateSupport;
        this.loginUser = loginUser;
    }

    @Override
    public void invoke(AirInstallImportVo airInstallVo, AnalysisContext context) {
        try {

            AirInstallBo airInstallBo = BeanUtil.toBean(airInstallVo, AirInstallBo.class);

            //TODO:根据某个字段，查询数据库表中是否存在记录，不存在就新增，存在就更新
            AirInstallVo airInstallVo1 = null;

            //airInstallVo1 = airInstallService.selectBySomefield(airInstallVo.getSomefield());
            if (ObjectUtil.isNull(airInstallVo1)) {
                //不存在就新增
                setBo(airInstallBo);
                ValidatorUtils.validate(airInstallBo);
                boolean inserted = airInstallService.insert(airInstallBo);

                if (inserted) {
                    successNum++;
                    successMsg.append("<br/>").append(successNum).append("、装机信息 记录导入成功");
                } else {
                    failureNum++;
                    failureMsg.append("<br/>").append(failureNum).append("、装机信息 记录导入失败");
                }
            } else if (isUpdateSupport) {
                //存在就更新
                airInstallBo.setId(airInstallVo1.getId());//主键
                airInstallBo.setVersion(airInstallVo1.getVersion());
                boolean updated = airInstallService.update(airInstallBo);
                if (updated) {
                    successNum++;
                    successMsg.append("<br/>").append(successNum).append("、装机信息 记录更新成功");
                } else {
                    failureNum++;
                    failureMsg.append("<br/>").append(failureNum).append("、装机信息 记录更新失败");
                }
            }
        } catch (Exception e) {
            failureNum++;
            String msg = "<br/>" + failureNum + "、装机信息 记录导入失败：";
            failureMsg.append(msg).append(e.getMessage());
            log.error(msg, e);
        }
    }

    private void setBo(AirInstallBo airInstallBo) {
        airInstallBo.setVersion(0);
        airInstallBo.setCreateBy(loginUser.getUserId());
        airInstallBo.setUpdateBy(loginUser.getUserId());
        airInstallBo.setTenantId(loginUser.getTenantId());
    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext context) {
        log.info("解析完成");
    }

    @Override
    public ExcelResult<AirInstallImportVo> getExcelResult() {
        return new ExcelResult<>() {

            @Override
            public ExcelResultRes getAnalysis() {
                if (failureNum > 0 && successNum == 0) {
                    failureMsg.insert(0, "很抱歉，导入失败！共 " + failureNum + " 条数据没有成功导入，错误如下：");
                    return ExcelResultRes.builder().logInfo(failureMsg.toString()).status("0").build();
                } else if (failureNum > 0 && successNum > 0) {
                    failureMsg.insert(0, "很抱歉，部分导入失败！共 " + failureNum + " 条数据没有成功导入，错误如下：");
                    return ExcelResultRes.builder().logInfo(failureMsg.toString()).status("2").build();
                } else {
                    successMsg.insert(0, "恭喜您，数据已全部导入成功！共 " + successNum + " 条，数据如下：");
                    return ExcelResultRes.builder().logInfo(successMsg.toString()).status("1").build();
                }
            }

            @Override
            public List<AirInstallImportVo> getList() {
                return null;
            }

            @Override
            public List<String> getErrorList() {
                return null;
            }
        };
    }
}
